#include "emmix.h"
void emmixfit1(double *y, int *pn, int *pp,int *pg,  int *pncov,int *pdist,
double * pro, double *mu, double * sigma, double *dof, double *delta,
double *tau, double *ev, double *elnv, double *ez1v,double *ez2v,
double *loglik, double *lk, double *aic, double *bic,
int *clust, int *pinfo,  int *itmax, double *epsilon, int *method)
{
int maxloop = 10;
*pinfo=0;
initfit_(y, pn, pp,pg, pncov,pdist, 
pro, mu, sigma, dof, delta,
tau, ev, elnv, ez1v,ez2v,
loglik, clust, pinfo, method,&maxloop);
if((*pinfo)) return;
emmixfit2(y, pn, pp,pg, pncov,pdist, pro, mu, sigma, dof,delta,
tau,ev,elnv,ez1v,ez2v,
loglik, lk, aic,bic,
clust,pinfo,itmax, epsilon,method);
return;
}
void emmixfit2(double *y, int *pn, int *pp,int *pg,  int *pncov,int *pdist,
double * pro, double *mu, double * sigma, double *dof, double *delta,
double *tau, double *ev, double *elnv, double *ez1v,double *ez2v,
double *loglik, double *lk, double *aic, double *bic,
int *clust, int *pinfo,  int *itmax, double *epsilon, int *method)
{
int vk=0,n=*pn,p=*pp,g=*pg;
double tmp,two=2;
if((*pdist) == 1)
emmvn_(y, pn, pp,pg,pncov,pro,mu, sigma,
	tau,						
	loglik,lk,pinfo,itmax,epsilon);
else if((*pdist) == 2)
emmvt_(y, pn, pp,pg,pncov,pro,mu, sigma, dof,
	tau, ev,					
	loglik,lk,pinfo,itmax,epsilon);
else if((*pdist) == 3)
emmsn_(y, pn,pp,pg,pncov,pro,mu, sigma, delta, 
	tau, ev, elnv,			
	loglik,lk,pinfo,itmax,epsilon);
else if((*pdist) == 4)
emmst_(y, pn,pp,pg,pncov,pro,mu, sigma, dof,delta, 
	tau, ev, elnv, ez1v, ez2v,
	loglik,lk,pinfo,itmax, epsilon);
if(*pinfo <= 1)
{
if (*pncov ==1)
   vk =(g-1) + p*g + p*(p+1)/2;
else if (*pncov ==3 ) 
   vk =(g-1) + p*g + g*p*(p+1)/2;
else if (*pncov == 2) 
   vk =(g-1) + p*g + p;
else if (*pncov == 4) 
   vk =(g-1) + p*g + g*p;
else if (*pncov == 5) 
   vk=g-1+p*g+g;
if(*pdist == 2) vk=vk+g;
else if(*pdist == 3) vk = vk + p*g ;
else if(*pdist == 4) vk = vk + g  + p*g;
tmp = (double)vk;
            *aic = -two*(*loglik) + two * tmp;
            *bic = -two*(*loglik) + log((double)n)* tmp;
F77_SUB(tau2clust)(tau, pn, pg, clust);
}
return;
}
void emmvn_(double *y, int *pn, int *pp,int *pg,int *pncov,
double * pro, double *mu, double * sigma, double *tau, 
double *loglik, double *lk, int *pinfo,int *itmax, double *epsilon)
{
int p=*pp,g=*pg,it;
double sumtau[*pg],zero=0.0;
double sigm[p*p],inv[p*p],lgdet,tmp,tmp2;
int i,j,k,count,info =0,save[p];
for(it=0;it< *itmax;it++) lk[it]=zero;
*pinfo =0;
tmp2=1;	  
for(it=0;it< *itmax;it++) {//start of EM loops
estepmvn_(y,pn,pp,pg,pro,mu,sigma,tau,sumtau,loglik,pinfo);
if(*pinfo) {	*pinfo = 3; return;}
lk[it]= *loglik;
tmp =1;
for(k=0;k<g;k++) { //the third dimension 
	for(i=0;i<p;i++) // row
		for(j=i;j<p;j++) // column
		sigm[j*p+i]=sigma[k*p*p+j*p+i];
F77_SUB(inverse3)(sigm, inv, &lgdet, &p, &info,&count, save);
if(info) {*pinfo=5;return;}
tmp = tmp*lgdet;
}
tmp2=tmp;
//  M-step
F77_SUB(mstepmvn)(y,pn,pp,pg,pncov,tau,sumtau,mu,sigma);
//  Check if converge
if(it == (*itmax-1) ) {*pinfo = 1;break;}
	
if(it < 10) continue;
if( (fabs(lk[it-10]-lk[it] ) < fabs(lk[it-10]* (*epsilon)))
&& (fabs(lk[it-1]-lk[it]) < fabs(lk[it-1]*(*epsilon)))) break;   
}      
//   end of EM algorithm loop
return;
}
void emmvt_(double *y, int *pn, int *pp,int *pg,int *pncov,
double * pro, double *mu, double * sigma, double *dof,
double *tau,double *xuu,
double *loglik, double *lk, int *pinfo,int *itmax, double *epsilon)
{
int it,g=*pg;
double sumtau[g],sumxuu[g],sumxuuln[g],zero=0.0;
for(it = 0;it < *itmax;it++) lk[it]=zero;
*pinfo =0;
for(it = 0;it < *itmax;it++) {
estepmvt_(y,pn,pp,pg,pro,mu,sigma,dof,tau,sumtau,
	xuu,sumxuu,sumxuuln,loglik,pinfo);
if(*pinfo) {	*pinfo = 3; return;}
lk[it]= *loglik;
F77_SUB(mstepmvt)(y,pn,pp,pg,pncov,tau,sumtau,xuu,sumxuu,sumxuuln,mu,sigma,dof);
if(it == (*itmax-1) ) {*pinfo = 1;break;}
if(it < 10) continue;
if( (fabs(lk[it-10]-lk[it] ) < fabs(lk[it-10]* (*epsilon)))
&& (fabs(lk[it-1]-lk[it])< fabs(lk[it-1]*(*epsilon)))) break;   
}      
return;
}
void emmsn_(double *y, int *pn, int *pp,int *pg, int *pncov,
double * pro, double *mu, double * sigma, double *delta,
double *tau, double *ev, double *vv, 
double *loglik, double *lk, int *pinfo,int *itmax,double *epsilon)
{
int it;
double sumtau[*pg];
const double zero=0.0;
for(it = 0;it < *itmax;it++) lk[it]=zero;
*pinfo = 0;
for(it = 0;it < *itmax;it++) {
F77_NAME(estepmsn)(y,pn,pp,pg,pro,mu,sigma,delta,
     tau,sumtau,ev,vv,loglik,pinfo);
if(*pinfo) { (*pinfo) = 3; return;}
lk[it]= *loglik;
F77_NAME(mstepmsn)(y,pn,pp,pg,pncov,tau,sumtau,ev,vv,mu,sigma,delta);
if(it == (*itmax-1) ) {(*pinfo) = 1;break;}
if(it < 10) continue;
if( (fabs(lk[it-10]-lk[it] ) < fabs(lk[it-10]* (*epsilon)))
&& (fabs(lk[it-1]-lk[it])< fabs(lk[it-1]*(*epsilon)))) break;   
}      
return;
}
void emmst_(double *y, int *pn, int *pp,int *pg, int *pncov,
double * pro, double *mu, double * sigma, double *dof, double *delta,
double *tau, double *ev, double *elnv, double *ez1v,double *ez2v,
double *loglik, double *lk, int *pinfo, int *itmax,  double *epsilon)
{
int it, meth[*pg];
double sumtau[*pg],sumvt[*pg],sumzt[*pg],sumlogv[*pg],zero=0.0;
double bx=200.0;
for(it=0;it<*pg;it++) {
meth[it] =1;
}
for(it = 0;it < *itmax;it++) lk[it]=zero;
*pinfo =0;
for(it = 0;it < *itmax;it++) {
F77_NAME(estepmst)(y,pn,pp,pg,pro,mu,sigma,dof,delta,
     tau,ev,elnv,ez1v,ez2v,sumtau,sumvt,sumzt,sumlogv,
     loglik,pinfo,meth);
if(*pinfo) {	*pinfo = 3; return;}
lk[it]= *loglik;
F77_NAME(mstepmst)(y,pn,pp,pg,pncov,
	tau,ev,ez1v,ez2v,sumtau,sumvt,sumzt,
    mu,sigma,delta);
F77_SUB(getdof)(pn, pg, sumtau, sumlogv, dof, &bx);
if(it == (*itmax-1) ) {*pinfo = 1;break;}
if(it < 10) continue;
if( (fabs(lk[it-10]-lk[it] ) < fabs(lk[it-10]* (*epsilon)))
&& (fabs(lk[it-1]-lk[it])< fabs(lk[it-1]*(*epsilon)))) break;   
}      
return;
}
