#include "emmix.h"
void initfit_(double *y, int *pn, int *pp,int *pg, int *pncov,int *pdist,
double * pro, double *mu, double * sigma, double *dof, double *delta,
double *tau, double *ev, double *elogv, double *ez1v,double *ez2v,
double *loglik, int *clust, int *pinfo, int *method, int *maxloop)
{
*pinfo =0;	  
if(*pdist == 1) 
	initmvn_(y,pn,pp,pg,pncov,pro,mu,sigma,    
	tau,                       loglik,clust,pinfo,maxloop);
else if(*pdist == 2)	
    initmvt_(y,pn,pp,pg,pncov,pro,mu,sigma,   dof,
	tau,ev,                    loglik,clust,pinfo,maxloop);
else if(*pdist == 3)	
    initmsn_(y, pn,pp,pg,pncov,pro,mu, sigma,     delta, 
    tau, ev, elogv,            loglik,clust,pinfo,maxloop);
else if(*pdist == 4)	
    initmst_(y, pn,pp,pg,pncov,pro,mu, sigma, dof,delta, 
    tau, ev, elogv, ez1v, ez2v,loglik,clust,pinfo,maxloop);
return;
}
void initmvn_(double *y, int *pn, int *pp,int *pg,int *pncov,
double * pro, double *mu, double * sigma, 
double *tau, double *loglik, int *clust, int *perror, int *maxloop)
{
int n=*pn;
int h,i;
const double zero=0.0, one=1.0;
double sumtau[*pg];
for(h=0;h< *pg;h++) {
sumtau[h]=zero;
for(i=0;i<n;i++) {
	tau[h*n+i]= zero;
	if(clust[i]==h+1) 
		tau[h*n+i]= one;
	sumtau[h] += tau[h*n+i];
}
pro[h]=sumtau[h]/(double)n;
}
F77_SUB(mstepmvn)(y,pn,pp,pg,pncov,tau,sumtau,mu,sigma);
*perror=0;
for(i=0;i< maxloop[0];i++) {
estepmvn_(y,pn,pp,pg,pro,mu,sigma,tau,sumtau,loglik,perror);
if(*perror) {	*perror = 2; return;}
F77_SUB(mstepmvn)(y,pn,pp,pg,pncov,tau,sumtau,mu,sigma);
}      
return;
}
void initmvt_(double *y, int *pn, int *pp,int *pg,int *pncov,
double * pro, double *mu, double * sigma, double *dof,
double *tau, double *xuu, 
double *loglik, int *clust, int *pinfo, int *maxloop)
{
int n=*pn,g=*pg;
int h,i;
const double zero=0.0, one=1.0;
double sumtau[g],sumxuu[g],sumxuuln[g];
for(h=0;h<g;h++) {
sumtau[h]=zero;
for(i=0;i<n;i++) {
	tau[h*n+i]= zero;
	if(clust[i]==h+1) 
		tau[h*n+i]= one;
	sumtau[h] += tau[h*n+i];
}
dof[h]= (double)4;
pro[h]=sumtau[h]/(double)n;
}
F77_SUB(mstepmvn)(y,pn,pp,pg,pncov,tau,sumtau,mu,sigma);
*pinfo=0;
for(i=0;i < maxloop[0];i++) {
estepmvt_(y,pn,pp,pg,pro,mu,sigma,dof,tau,sumtau,
xuu,sumxuu,sumxuuln,loglik,pinfo);
if(*pinfo) {	*pinfo = 2; return;}
F77_SUB(mstepmvt)(y,pn,pp,pg,pncov,tau,sumtau,xuu,sumxuu,sumxuuln,mu,sigma,dof);
}      
return;
}
void initmsn_(double *y, int *pn, int *pp,int *pg, int *pncov,
double * pro, double *mu, double * sigma, double *delta,
double *tau, double *ev, double *vv, 
double *loglik,int *clust,int *pinfo, int *maxloop)
{
int n=*pn,g=*pg;
int i,h;
double sumtau[g];
const double one = 1.0,zero=0.0;
for(h=0;h<g;h++) {
 sumtau[h]=zero;
 for(i=0;i<n;i++) {
 tau[h*n+i]=zero;
  if(clust[i] == (h+1)) {
    tau[h*n+i]= one;
    sumtau[h] += tau[h*n+i];
 } 
 }
 pro[h]= sumtau[h]/(double)n;
 } 
F77_SUB(mstepmvn)(y,pn,pp,pg,pncov,tau,sumtau,mu,sigma);
F77_NAME(skew)(y,pn,pp,pg,tau,sumtau,mu,sigma,delta);
*pinfo=0;
for(i=0;i< maxloop[0];i++) {
F77_NAME(estepmsn)(y,pn,pp,pg,pro,mu,sigma,delta,tau,sumtau,ev,vv,loglik,pinfo);
if(*pinfo) {	*pinfo = 2; return;}
F77_NAME(mstepmsn)(y,pn,pp,pg,pncov,tau,sumtau,ev,vv,mu,sigma,delta);
}
return;
}
void initmst_(double *y, int *pn, int *pp,int *pg, int *pncov,
double *pro, double *mu, double * sigma, double *dof, double *delta,
double *tau, double *ev, double *elogv, double *ez1v,double *ez2v,
double *loglik,int *clust,int *pinfo, int *maxloop)
{
int n=*pn,g=*pg;
int i,h, method[g];
double sumtau[g],sumvt[g],sumzt[g],sumlogv[g];
const double one = 1.0,zero=0.0;
for(h=0;h<g;h++) {
 sumtau[h]=zero;
 for(i=0;i<n;i++) {
 tau[h*n+i]=zero;
 if(clust[i] == (h+1)) {
    tau[h*n+i]= one;
    sumtau[h] += tau[h*n+i];
 } 
 }
 pro[h]= sumtau[h]/(double)n;
 method[h] = 3;
 dof[h] = (double)4;
} 
F77_SUB(mstepmvn)(y,pn,pp,pg,pncov,tau,sumtau,mu,sigma);
F77_NAME(skew)(y,pn,pp,pg,tau,sumtau,mu,sigma,delta);
*pinfo=0;
for(i=0;i < maxloop[0];i++) {
F77_NAME(estepmst)(y,pn,pp,pg,pro,mu,sigma,dof,delta,
     tau,ev,elogv,ez1v,ez2v,sumtau,sumvt,sumzt,sumlogv,
     loglik,pinfo,method);
if(*pinfo) {	*pinfo = 2; return;}
F77_NAME(mstepmst)(y,pn,pp,pg,pncov,
	tau,ev,ez1v,ez2v,sumtau,sumvt,sumzt,
     mu,sigma,delta);
}
return;
}
